// These extensions affect ALL client side objects. Be very careful about introducing new ones as they may break existing client-side libraries

Array.prototype.include = function(value){ return(this.indexOf(value) != -1); };
Array.prototype.any = function(){ return(this.length > 0); };


// Helper methods used by SocketStream to get and set session cookies
// Cookies are set by the browser, not via the server in HTTP headers to allow full caching of the static index.html file

window.getCookie = function(c_name) {
  if (document.cookie.length > 0) {
    c_start = document.cookie.indexOf(c_name + "=");
    if (c_start != -1) {
      c_start = c_start + c_name.length + 1;
      c_end = document.cookie.indexOf(";",c_start);
      if (c_end == -1) c_end = document.cookie.length;
      return unescape(document.cookie.substring(c_start,c_end));
    }
  }
  return "";
};

window.setCookie = function(c_name, value, expiredays) {
  var exdate = new Date();
  exdate.setDate(exdate.getDate() + expiredays);
  document.cookie = c_name+ "=" + escape(value) + ((expiredays==null) ? "" : ";expires="+exdate.toUTCString());
};
